<!DOCTYPE html>
<html lang="pt-br" spellcheck="false">

  <head>
    <title>Smart Locker - Tecban - Menno</title>
    <meta name="description" content="Tecban Wise System"/>
    <meta name="theme-color" content="#764ABC"/>
    <meta name="google" content="notranslate"/>
    <meta http-equiv='cache-control' content='no-cache'/>
    <meta http-equiv='pragma' content='no-cache'/>
    <meta http-equiv='expires' content='0'/>
    <meta charset="utf-8"/> 
    <meta http-equiv="Permissions-Policy" content="interest-cohort=()"/>
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no"/> <!-- impede o zoom da tela -->
    <link rel="shortcut icon" href="./system/images/favicon.ico" type="image/x-icon" />
    <link rel="stylesheet" href="./system/style/style.css">
    <script type="text/javascript" src="./system/scripts/webapi.js"></script>
    <script type="text/javascript" src="./system/scripts/escpos.js"></script>
    <script type="text/javascript" src="./system/scripts/qrcode.js"></script>
  </head>
  <body>

    <!-- Área do Logo e Nome -->
    <div id="logo">
      <img src="./system/images/logos.png">
    </div>

    <!-- Área de Controle -->
    <div id="controll">

      <!-- Display de mensagens ao usuário-->
      <div id="message-display">******** Smart Locker - Tecban ******** <br><br>Aguarde...</div>

      <!-- Display de Teclado -->
      <div id="keyboard-display">CÓDIGO</div>

      <!-- Portas -->
      <div id="container-ports">
        <div id="title-ports">Portas disponíveis</div>
      </div>

      <!-- Teclado -->
      <div id="container-keyboard">
        <button id="but-1" class="button" type="button" onclick="ButEvent(1)">1</button>
        <button id="but-2" class="button" type="button" onclick="ButEvent(2)">2</button>
        <button id="but-3" class="button" type="button" onclick="ButEvent(3)">3</button>
        <button id="but-4" class="button" type="button" onclick="ButEvent(4)">4</button>
        <button id="but-5" class="button" type="button" onclick="ButEvent(5)">5</button>
        <button id="but-6" class="button" type="button" onclick="ButEvent(6)">6</button>
        <button id="but-7" class="button" type="button" onclick="ButEvent(7)">7</button>
        <button id="but-8" class="button" type="button" onclick="ButEvent(8)">8</button>
        <button id="but-9" class="button" type="button" onclick="ButEvent(9)">9</button>
        <button id="but-confirma" class="button-background-green" type="button" onclick="ButConfirma()">CONFIRMA</button>
        <button id="but-0" class="button" type="button" onclick="ButEvent(0)">0</button>
        <button id="but-cancela" class="button-background-orange" type="button" onclick="ButCancela()">CANCELA</button>
      </div>
      <div id="container-qrcode">
        <div id="qrcode"></div>
        <div id="senha"><b>Senha: 12345678</b></div>
        <div id="porta">Porta 1</div>
        <button id="but-confirma" class="button-background-green-qrcode" type="button" onclick="ButCancela()">CONFIRMA</button>
        <button id="but-cancela" class="button-background-orange" type="button" onclick="ButCancelaQrCode()">CANCELA</button>
      </div>
    </div>

<!-- Lógica para desempenho de funcionalidades de botões e interação com locker e apis-->
    <script>
    // -------- Variáveis --------------- //
      var Tamanhos = [];
      var Lockers = null;           //Lista das portas registradas no armario por este arquivo html    
      var ActivePage = null;
      var numberDisplay = "";
      var QRCodeImg = null; 
    // ------ Inicialização Funções ----- //
    window.addEventListener('load', async (ev) => {
      await qrCodeNone();               // Esconde a div de Qr Code e exibe a div de teclado
      await InitLockers();              // Carrega Lista das portas do Armario
      
    });

    // ------- Json de mensagens -------- //
    var messages = {
      display_padrao:"Escolha uma porta e clique em [CONFIRMA] <br> ou <br> - Utilize o QRcode ou CardNFC <br> - Digite a senha ou coloque o dedo",
      erro_admin:"Ops. Algum erro aconteceu. <br> Por favor avise o administrador do sistema",
      erro_tente_novamente:"Ops. Algum erro aconteceu. <br> Tente novamente.",
      erro_portas:"Erro na busca de portas",
      porta_aberta:"A porta solicitada está aberta. <br> Por favor coloque seu pacote e feche a porta. <br> Após fechar corretamente a porta, clique e [CONFIRMA]. <br> Caso dejeje cancelar a operação, basta clicar em [CANCELA]",
      porta_continua_aberta:"A porta continua aberta. <br> Por favor verifique o fechamento correto da porta. <br> Após fechar corretamente a porta, clique e [CONFIRMA]. <br> Caso dejeje cancelar a operação, basta clicar em [CANCELA]",
      porta_bloqueada:"A porta está bloqueada.",
      porta_ocupada:"A porta está ocupada.",
      confirma_abertura:"Para abrir a porta, clique em [CONFIRMA] <br> Para cancelar, clique em [CANCELA]",
      tirar_foto:"Tire uma foto do QR Code e Senha com seu celular. <br><br> Após tirar a foto, clique em [CONFIRMA]",
      sem_pacote:"Não existe pacote nesta porta.",
      retira_pacote:"Porta ABERTA - Favor retirar seu pacote"
    }

    // -------- Funções ----------------- //

      // Função que esconde a div de QRcode e exibe a div de teclado
      async function qrCodeNone(){
        var teclado = document.getElementById("container-keyboard");
        var qr = document.getElementById("container-qrcode");
        teclado.style.display = "inherit";
        qr.style.display = "none";
      }

      // Função que esconde a div de teclado e exibe a div de qr code
      async function qrCodeInherit(){
        var teclado = document.getElementById("container-keyboard");
        var qr = document.getElementById("container-qrcode");
        teclado.style.display = "none";
        qr.style.display = "inherit";
      }

      // Função que insere no display CÓDIGO o dígito pressionado
      async function ButEvent(num){
        numberDisplay += num.toString();
        var disp = document.querySelector("#keyboard-display");
        var dispMessage = document.querySelector("#message-display");
        disp.innerHTML = numberDisplay;
      }

      // Função que define a lógica de confirmar a transação
      async function ButConfirma(){
        var numCaracteres = numberDisplay.length
        var dispMessage = document.querySelector("#message-display");
        var disp = document.querySelector("#keyboard-display");
        disp.innerHTML = "CÓDIGO";
        // Identifica que é porta
        if(numCaracteres > 0 && numCaracteres < 4){
          dispMessage.innerHTML = "Aguarde...";

          // Pega o estado da porta
          try{
            await WebApi({Call:"Statdoor",Args:parseInt(numberDisplay)});
          }catch(e){
            
          }
          try{
            var ret = await WebApi({Call:"Statdoor",Args:parseInt(numberDisplay)}); // Pega o estado da porta
            if(ret.Call == "Statdoor"){
              if(ret.Args == "A"){
                dispMessage.innerHTML = messages.porta_aberta;
                disp.innerHTML = "Porta Aberta - " + numberDisplay;
                return;
              }else if(ret.Args == "L"){
                var lcRet = {};
                for(let x = 0; x < 3;x++){
                  try{
                    lcRet = await WebApi( {Call:"Acessa",Args:parseInt(numberDisplay)} );   //Busca estado da porta
                    break;
                  }catch(e){
                    console.log("Erro api config | tentativa " + x);
                  }
                }
                if(lcRet.Call != "Acessa" && lcRet.Args != "ACK"){
                  dispMessage.innerHTML = messages.erro_tente_novamente;
                  disp.innerHTML = "CÓDIGO";
                  return;
                }
                dispMessage.innerHTML = messages.porta_aberta;
                disp.innerHTML = "Porta Aberta";
                return;
              }else if(ret.Args == "B"){
                dispMessage.innerHTML = messages.porta_bloqueada;
              }else if(ret.Args == "O"){
                dispMessage.innerHTML = messages.porta_ocupada;
              }
            }else{
              dispMessage.innerHTML = messages.erro_tente_novamente;
              console.log("Erro Statdoor: " + ret.Args);
            }
          }catch(e){
            dispMessage.innerHTML = messages.erro_tente_novamente;
            console.log(e);
          }
        }

        // Identifica que é senha
        else if(numCaracteres == 8){
          dispMessage.innerHTML = "Aguarde...";

          // Pega o estado da porta
          try{
            await WebApi({Call:"Statdoor",Args:parseInt(numberDisplay)});
          }catch(e){
            
          }
          try{
            var ret = await WebApi({Call:"Statdoor",Args:parseInt(numberDisplay)}); // Pega o estado da porta
            if(ret.Call == "Statdoor"){
              if(ret.Args == "A"){
                dispMessage.innerHTML = messages.porta_aberta;
                disp.innerHTML = "Porta Aberta - " + numberDisplay;
                return;
              }else if(ret.Args == "L"){
                dispMessage.innerHTML = messages.sem_pacote;
              }else if(ret.Args == "B"){
                dispMessage.innerHTML = messages.porta_bloqueada;
              }else if(ret.Args == "O"){
                
                // Abertura da porta
                var lcRet = {};
                for(let x = 0; x < 3;x++){
                  try{
                    lcRet = await WebApi( {Call:"Acessa",Args:parseInt(numberDisplay)} );   //Busca estado da porta
                    break;
                  }catch(e){
                    console.log("Erro api acessa | tentativa " + x);
                  }
                }
                if(lcRet.Call != "Acessa" && lcRet.Args != "ACK"){
                  dispMessage.innerHTML = messages.erro_tente_novamente;
                  disp.innerHTML = "CÓDIGO";
                  return;
                }

                // Api de cancelamento do registro.
                var ret = {};
                for(let x = 0; x < 3;x++){
                  try{
                    ret = await WebApi( {Call:"Retira",Args:parseInt(numberDisplay)} );   //Busca estado da porta
                    break;
                  }catch(e){
                    console.log("Erro api retira | tentativa " + x);
                  }
                }
                if(ret.Call != "Retira" && ret.Args != "ACK"){
                  dispMessage.innerHTML = messages.erro_tente_novamente;
                  disp.innerHTML = "CÓDIGO";
                  return;
                }

                // Menssagem para a retirada do pacote.
                dispMessage.innerHTML = messages.retira_pacote;
                disp.innerHTML = "CÓDIGO";
                var message = "";

                // Espera 5 segundos e retorna a tela inicial.
                setTimeout(message, 5000);
                ButCancela();
                return;
              }
            }else{
              dispMessage.innerHTML = messages.erro_tente_novamente;
              console.log("Erro Statdoor: " + ret.Args);
            }
          }catch(e){
            dispMessage.innerHTML = messages.erro_tente_novamente;
            console.log(e);
          }
        }

        // Identifica que é QR Code
        else if(numCaracteres > 25){
          console.log("é QR Code");
          dispMessage.innerHTML = messages.confirma_abertura;
          return;
        }

        // Identifica que fechou a porta
        else if(numCaracteres > 15 && numCaracteres < 18){
          dispMessage.innerHTML = "Aguarde... <br> Gerando QR Code e Senha";
          var porta = parseInt(numberDisplay.slice(15).trim());
          var lcRet = {};
          for(let x = 0; x < 3;x++){
            try{
              lcRet = await WebApi( {Call:"Statdoor",Args:porta} );   //Busca estado da porta
              break;
            }catch(e){
              console.log("Erro api config | tentativa " + x);
            }
          }
          if(lcRet.Call != "Statdoor" || lcRet.Args == "NAK"){
            dispMessage.innerHTML = messages.erro_admin;
            disp.innerHTML = "CÓDIGO";
            return;
          }
          if(lcRet.Args == "A"){
            dispMessage.innerHTML = messages.porta_continua_aberta;
            disp.innerHTML = "Porta Aberta - " + numberDisplay;
            return;
          }
          else if(lcRet.Args == "L"){
            var ret = {};
            for(let x = 0; x < 3;x++){
              try{
                ret = await WebApi( {Call:"Insere",Args:porta} );   //Busca estado da porta
                break;
              }catch(e){
                console.log("Erro api config | tentativa " + x);
              }
            }
            if(ret.Call != "Insere" || ret.Args !=  porta){
              dispMessage.innerHTML = messages.erro_admin;
              disp.innerHTML = "CÓDIGO";
              return;
            }
            qrCodeInsert(ret.QRCode, ret.Secure, porta);
            dispMessage.innerHTML = messages.tirar_foto;
            disp.innerHTML = "Foto concluida";
            return;
          }else{
            dispMessage.innerHTML = messages.erro_admin;
            disp.innerHTML = "CÓDIGO";
            return;
          }

        }else if(numCaracteres == 14){
          ButCancela();
          return;
        }

        // Identifica erro de caracteres
        else{
          dispMessage.innerHTML = messages.erro_tente_novamente;
          disp.innerHTML = "CÓDIGO";
          console.log(e);
        }

        numberDisplay = "";
      }

      // Função que define a lógica de cancelar a transação
      async function ButCancela(){
        var disp = document.querySelector("#keyboard-display");
        var dispMessage = document.querySelector("#message-display");
        disp.innerHTML = "CÓDIGO";
        dispMessage.innerHTML = "Aguarde..."
        numberDisplay = "";
        InitLockers();
      }

      // Função que implementa a lógica após o click na porta disponível
      async function clickPort(port){
        var disp = document.querySelector("#keyboard-display");
        var dispMessage = document.querySelector("#message-display");
        if(port.length > 3 || port.length == 0){
          disp.innerHTML = "CÓDIGO";
          dispMessage.innerHTML = messages.erro_admin;
          return
        }
        
        disp.innerHTML = port;
      }

      // Função que carrega lista das portas do Armario.
      async function InitLockers() {
      
        // Variáveis
        var p = document.querySelector("#title-ports");
        var dispMessage = document.querySelector("#message-display");
        let lcRet = {};

        // Muda texto do display para 'Aguarde...'
        p.innerHTML = "Aguarde...";

        // Chama API para buscar lista das portas disponíveis
        for(let x = 0; x < 3;x++){
          try{
            lcRet = await WebApi( {Call:"Config",Args:'PortList'} );   //Busca estado da porta
            break;
          }catch(e){
            console.log("Erro api config | tentativa " + x);
          }
        }
        
        // Verifica e retorn erro no retorno da chamada da API
        if( (lcRet.Call != "PortList") || (lcRet.Args != "ACK") ) {
          console.log("Erro Config: " + lcRet.Args);
          p.innerHTML = messages.erro_portas;
          dispMessage.innerHTML = messages.erro_admin;
          return;
        }

        // Em caso de sucesso, muda texto do display
        dispMessage.innerHTML = messages.display_padrao;

        // Insere Botões das portas no HTML
        let lcDivSize = document.getElementById("container-ports");
        for(idx = 1; idx < lcRet.Size; idx++){
          lcDivSize.insertAdjacentHTML('beforeend',`<button class="port" id="S${lcRet.Rows[idx][1]}" type="button" onclick="clickPort(${lcRet.Rows[idx][0]}) >${lcRet.Rows[idx][0]} - ${lcRet.Rows[idx][1]}cm</button>`);
        }
        return true;
      }

      // Função que insere a imagem do QR Code e a senha na tela
      async function qrCodeInsert(qr_code, senha, porta){

        // Cria o objeto QR Code
        QRCdImg = new QRCode( document.getElementById("qrcode"), {
          text: "https://www.example.com",
          colorLight : "#ffffff",
          colorDark : "#000000",
          height: 256,
          width: 256,
        });
        QRCdImg.clear();

        // Insere o QR Code na instancia.
        try{
          await QRCdImg.makeCode(qr_code);
        }catch(e){
          dispMessage.innerHTML = messages.erro_admin;
          console.log(e);
        }

        // Modifica o texto do campo Senha e Porta
        var sen = document.querySelector("#senha");
        var por = document.querySelector("#porta");
        sen.innerHTML = "Senha: " + senha;
        por.innerHTML = "Porta " + porta;

        // Torna a div qr code visível
        qrCodeInherit();
        
      }
    

    </script>
    

  </body>
</html>